Skip to main content
Update an application through SLang
curl --request PUT \
  --url https://sapi.withsutro.com/applications/{applicationId}/slang \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-sutro-api-client: <api-key>' \
  --data '
{
  "slang": "<string>",
  "entryFile": "<string>",
  "sourceFiles": [
    {
      "path": "<string>",
      "content": "<string>"
    }
  ]
}
'
import requests

url = "https://sapi.withsutro.com/applications/{applicationId}/slang"

payload = {
"slang": "<string>",
"entryFile": "<string>",
"sourceFiles": [
{
"path": "<string>",
"content": "<string>"
}
]
}
headers = {
"Authorization": "Bearer <token>",
"x-sutro-api-client": "<api-key>",
"Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.text)
const options = {
method: 'PUT',
headers: {
Authorization: 'Bearer <token>',
'x-sutro-api-client': '<api-key>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
slang: '<string>',
entryFile: '<string>',
sourceFiles: [{path: '<string>', content: '<string>'}]
})
};

fetch('https://sapi.withsutro.com/applications/{applicationId}/slang', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));


{
  "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
  "scode": {
    "requirements": [
      {
        "id": "<string>",
        "description": "<string>",
        "parentId": "<string>"
      }
    ],
    "appId": "<string>",
    "version": "<string>",
    "appOverview": {
      "name": "<string>",
      "jobToBeDone": "<string>",
      "unsupportedUserJourneys": [
        {
          "name": "<string>",
          "description": "<string>",
          "reason": "<string>",
          "steps": [
            "<string>"
          ]
        }
      ],
      "draftUserJourneys": [
        {
          "name": "<string>",
          "outcome": "<string>",
          "steps": [
            "<string>"
          ]
        }
      ]
    },
    "appDescription": "<string>",
    "appDraft": {
      "sitemap": {
        "nodes": [
          {
            "id": "<string>",
            "route": "<string>",
            "content": [
              {
                "title": "<string>",
                "description": "<string>"
              }
            ]
          }
        ],
        "edges": [
          {
            "from": "<string>",
            "to": "<string>",
            "type": "<string>"
          }
        ]
      },
      "requirements": [
        {
          "id": "<string>",
          "description": "<string>",
          "parentId": "<string>"
        }
      ]
    },
    "domainModel": {
      "models": [
        {
          "name": "<string>",
          "fields": [
            {
              "name": "<string>",
              "type": "<string>"
            }
          ],
          "requirements": [
            {
              "id": "<string>",
              "description": "<string>",
              "parentId": "<string>"
            }
          ],
          "isUserModel": true
        }
      ]
    },
    "actions": [
      {
        "id": "<string>",
        "effects": [
          {
            "actionEffectId": "<string>",
            "effect": "<string>",
            "params": {},
            "bindParams": {},
            "next": "<string>",
            "onError": {
              "nextId": "<string>",
              "continueOriginalFlow": true
            }
          }
        ],
        "startEffectId": "<string>",
        "bindReturnValue": "<string>",
        "onError": {
          "nextId": "<string>",
          "continueOriginalFlow": true
        },
        "referenceRequirements": [
          "<string>"
        ]
      }
    ],
    "triggers": [
      {
        "trigger": {
          "id": "<string>",
          "type": "<unknown>",
          "eventName": "<string>",
          "payload": {}
        },
        "actionId": "<string>",
        "initialState": {},
        "validation": [
          "<string>"
        ],
        "isPublic": true,
        "referenceRequirements": [
          "<string>"
        ]
      }
    ],
    "userModelId": "<string>",
    "models": [
      {
        "id": "<string>",
        "name": "<string>",
        "fields": [
          {
            "id": "<string>",
            "name": "<string>",
            "relationshipOwner": true,
            "min": 123,
            "max": 123,
            "to": "<string>",
            "accessControl": {
              "rules": [
                {
                  "criteria": "<string>"
                }
              ]
            },
            "computed": "<string>",
            "defaultValue": "<unknown>",
            "enum": [
              "<string>"
            ]
          }
        ],
        "accessControl": {
          "rules": [
            {
              "criteria": "<string>"
            }
          ]
        },
        "referenceRequirements": [
          "<string>"
        ]
      }
    ],
    "personas": [
      {
        "name": "<string>"
      }
    ]
  },
  "projectId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
  "status": {
    "jobs": [
      {
        "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
        "implementationJobId": "<string>",
        "customerId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
        "projectId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
        "metadata": {},
        "errorMessage": "<string>",
        "errorStack": "<string>",
        "startedAt": "<string>",
        "completedAt": "<string>"
      }
    ]
  },
  "isActive": true,
  "name": "<string>",
  "serverVersion": "<string>",
  "lastPublishedAt": "2023-11-07T05:31:56Z",
  "lastUnpublishedAt": "2023-11-07T05:31:56Z"
}

Authorizations

Authorization
string
header
required

Builder authentication and authorization

x-sutro-api-client
string
header
required

A unique identifier for the API Client making a request

Path Parameters

applicationId
string<uuid>
required

Body

slang
string
required

SLang source code for the entry file

entryFile
string

Path to the entry SLang source file when uploading a source tree

sourceFiles
object[]

Full SLang source tree to compile and persist

Response

The updated application

An application

id
string<uuid>
required

Unique identifier for the application

scode
SCode representation of an Application · object
required

The application's SCode definition

projectId
string<uuid>
required

The project this application belongs to

status
object
required
isActive
boolean
required

Whether the application is currently active for billing/runtime purposes

name
string

The name of the application

serverVersion
string

The current saved server version (semver)

lastPublishedAt
string<date-time>

When the application was last published

lastUnpublishedAt
string<date-time>

When the application was last unpublished